"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./../markers/RectMarker/index");
var index_2 = require("./../markers/CoverMarker/index");
var index_3 = require("./../markers/TextMarker/index");
var index_4 = require("./../markers/ArrowMarker/index");
var index_5 = require("./../markers/HighlightMarker/index");
var ToolbarItem_1 = require("./ToolbarItem");
var LineMarker_1 = require("../markers/LineMarker");
var OkIcon = require('../assets/check.svg');
var DeleteIcon = require('../assets/eraser.svg');
var CloseIcon = require('../assets/times.svg');
exports.dragToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'drag',
    tooltipText: 'Drag',
    icon: require('../assets/drag.svg')
});
exports.highlightMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'cover-marker',
    tooltipText: 'Hightlight',
    shortcut: 'Shift+H',
    icon: require('../assets/highlight.svg'),
    markerType: index_5.HighlightMarker,
    draggable: true
});
exports.arrowMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'arrow-marker',
    tooltipText: 'Arrow',
    shortcut: 'Shift+A',
    icon: require('../assets/arrow.svg'),
    markerType: index_4.ArrowMarker,
    draggable: true
});
exports.textMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'text-marker',
    tooltipText: 'Text',
    shortcut: 'Shift+T',
    icon: require('../assets/text.svg'),
    markerType: index_3.TextMarker,
    draggable: true
});
exports.coverMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'cover-marker',
    tooltipText: 'Cover',
    shortcut: 'Shift+C',
    icon: require('../assets/cover.svg'),
    markerType: index_2.CoverMarker,
    draggable: true
});
exports.rectMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'rect-marker',
    tooltipText: 'Rectangle',
    shortcut: 'Shift+R',
    icon: require('../assets/rect.svg'),
    markerType: index_1.RectMarker,
    draggable: true
});
exports.lineMarkerToolbarItem = new ToolbarItem_1.ToolbarItem({
    name: 'line-marker',
    tooltipText: 'Line',
    shortcut: 'Shift+L',
    icon: require('../assets/line.svg'),
    markerType: LineMarker_1.LineMarker,
    draggable: true
});
exports.closeToolbarItem = new ToolbarItem_1.ToolbarItem({
    icon: CloseIcon,
    name: 'close',
    tooltipText: 'Close'
});
exports.separatorToolbarItem = new ToolbarItem_1.ToolbarItem({ name: 'separator', tooltipText: '' });
function getToolbars(page) {
    var toolbars = [
        {
            icon: DeleteIcon,
            name: 'delete',
            tooltipText: 'Delete'
        },
        exports.rectMarkerToolbarItem,
        exports.coverMarkerToolbarItem,
        exports.highlightMarkerToolbarItem,
        exports.lineMarkerToolbarItem,
        exports.arrowMarkerToolbarItem,
        exports.textMarkerToolbarItem
    ];
    if (!page) {
        toolbars.push.apply(toolbars, [
            {
                icon: OkIcon,
                name: 'ok',
                tooltipText: 'OK'
            }
        ]);
    }
    return toolbars;
}
exports.getToolbars = getToolbars;
