"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var MirrorWhiteboard_1 = require("../MirrorWhiteboard");
var EventHub_1 = require("../../event/EventHub");
var windowSize = 60 * 1000;
var duration = 0.05;
var ReplayWhiteboard = (function (_super) {
    __extends(ReplayWhiteboard, _super);
    function ReplayWhiteboard() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.leftEvents = [];
        _this.currentRelativeTime = 0;
        _this.loadedRelativeTime = -1;
        _this.loadingLock = false;
        _this.seekingLock = false;
        _this.seek = function () {
            if (_this.seekingLock) {
                return;
            }
            _this.seekingLock = true;
            if (_this.loadedRelativeTime < _this.currentRelativeTime) {
                _this.loadEvents();
            }
            var waitingEvents = [];
            var leftEvents = [];
            _this.leftEvents.forEach(function (e, i) {
                if (e.timestamp && e.timestamp < _this.currentRelativeTime + _this.recordStartTime) {
                    waitingEvents.push(e);
                }
                else {
                    leftEvents.push(e);
                }
            });
            _this.leftEvents = leftEvents;
            waitingEvents.forEach(function (e) {
                _this.perform(e);
            });
            _this.currentRelativeTime += duration;
            _this.seekingLock = false;
        };
        _this.perform = function (e) {
            _this.eventHub.emit('sync', e);
        };
        return _this;
    }
    ReplayWhiteboard.prototype.setContext = function (recordStartTime, onLoad) {
        var _this = this;
        this.recordStartTime = recordStartTime;
        this.onLoad = onLoad;
        if (this.interval) {
            clearInterval(this.interval);
        }
        this.interval = setInterval(function () {
            _this.seek();
        }, duration * 1000);
    };
    ReplayWhiteboard.prototype.setCurrentRelativeTime = function (time) {
        this.currentRelativeTime = time;
        this.loadedRelativeTime = this.currentRelativeTime - 1;
    };
    ReplayWhiteboard.prototype.close = function () {
        _super.prototype.close.call(this);
        if (this.interval) {
            clearInterval(this.interval);
        }
    };
    ReplayWhiteboard.prototype.init = function () {
        this.eventHub = new EventHub_1.EventHub();
        _super.prototype.init.call(this);
    };
    ReplayWhiteboard.prototype.loadEvents = function () {
        var _this = this;
        if (this.onLoad && !this.loadingLock) {
            this.loadingLock = true;
            var startTime = this.recordStartTime + this.currentRelativeTime;
            var endTime = startTime + windowSize;
            this.onLoad(startTime, endTime)
                .then(function (events) {
                var _a;
                _this.loadedRelativeTime = _this.currentRelativeTime;
                (_a = _this.leftEvents).push.apply(_a, (events || []));
            })
                .finally(function () {
                _this.loadingLock = false;
            });
        }
    };
    return ReplayWhiteboard;
}(MirrorWhiteboard_1.MirrorWhiteboard));
exports.ReplayWhiteboard = ReplayWhiteboard;
