import { WhitePage } from '../../whiteboard/WhitePage/index';
import { PositionType } from '../../utils/layout';
import { onSyncFunc, EventType } from '../../event/SyncEvent';
import { MarkerType } from '../types';
import { MarkerSnap } from '../../whiteboard/AbstractWhiteboard/snap';
import { Drawboard } from '../../drawboard/Drawboard/index';
import { DomEventAware } from '../../renderer/DomEventAware/index';
export declare class BaseMarker extends DomEventAware {
    id: string;
    type: MarkerType;
    page?: WhitePage;
    drawboard?: Drawboard;
    onChange: onSyncFunc;
    static createMarker: (page?: WhitePage | undefined) => BaseMarker;
    visual: SVGGElement;
    renderVisual: SVGGElement;
    onSelected: (marker: BaseMarker) => void;
    defs: SVGElement[];
    width: number;
    height: number;
    isActive: boolean;
    isDragging: boolean;
    isResizing: boolean;
    reactToManipulation(type: EventType, { dx, dy, pos }?: {
        dx?: number;
        dy?: number;
        pos?: PositionType;
    }): void;
    manipulate: (ev: MouseEvent) => void;
    endManipulation(): void;
    select(): void;
    deselect(): void;
    captureSnap(): MarkerSnap;
    applySnap(snap: MarkerSnap): void;
    destroy(): void;
    protected resize(x: number, y: number, cb?: Function): void;
    protected resizeByEvent(x: number, y: number, pos?: PositionType): void;
    move: (dx: number, dy: number) => void;
    moveTo: (x: number, y: number) => void;
    protected init(): void;
    protected addToVisual: (el: SVGElement) => void;
    protected addToRenderVisual: (el: SVGElement) => void;
    protected onMouseDown: (ev: MouseEvent) => void;
    protected onMouseUp: (ev: MouseEvent) => void;
    protected onMouseMove: (ev: MouseEvent) => void;
}
