import { WhitePage } from '../../whiteboard/WhitePage/index';
import { BaseMarker } from '../BaseMarker';
import { PositionType } from '../../utils/layout';
import { MarkerSnap } from '../../whiteboard/AbstractWhiteboard/snap';
import { LinearBound } from '../types';
export declare class LinearMarker extends BaseMarker implements LinearBound {
    static createMarker: (page?: WhitePage | undefined) => LinearMarker;
    private readonly MIN_LENGTH;
    x1: number;
    y1: number;
    x2: number;
    y2: number;
    protected markerLine: SVGLineElement;
    private markerBgLine;
    private controlBox;
    private controlGrips;
    private activeGrip;
    getLineLength: (x1: number, y1: number, x2: number, y2: number) => number;
    captureSnap(): MarkerSnap;
    applySnap(snap: MarkerSnap): void;
    endManipulation(): void;
    select(): void;
    deselect(): void;
    protected init(): void;
    protected resize(x: number, y: number, onPosition?: (pos: PositionType) => void): void;
    protected resizeByEvent(x: number, y: number, pos?: PositionType): void;
    private addControlBox;
    private adjustControlBox;
    private addControlGrips;
    private createGrip;
    private gripMouseDown;
    private gripMouseUp;
    private gripMouseMove;
    private positionLine;
    private positionGrips;
    private positionGrip;
}
