import { MarkerType } from '../types';
import { RectangularMarker } from '../RectangularMarker';
import { WhitePage } from '../../whiteboard/WhitePage';
import { PositionType } from '../../utils/layout';
import { MarkerSnap } from '../../whiteboard/AbstractWhiteboard/snap';
export declare class TextMarker extends RectangularMarker {
    type: MarkerType;
    static createMarker: (page?: WhitePage | undefined) => TextMarker;
    protected readonly MIN_SIZE = 50;
    private readonly DEFAULT_TEXT;
    private text;
    private inDoubleTap;
    private textElement;
    private editor;
    private editorTextArea;
    setText(text: string): void;
    captureSnap(): MarkerSnap;
    applySnap(snap: MarkerSnap): void;
    protected init(): void;
    protected resize(x: number, y: number, onPosition?: (pos: PositionType) => void): void;
    private renderText;
    private sizeText;
    private onDblClick;
    private onTap;
    private showEditor;
    private onEditorOkClick;
    private closeEditor;
    private onEditorKeyDown;
}
